"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

Lookup subclass:#JavaLookup
	instanceVariableNames:'searchStatic'
	classVariableNames:'Instance Static'
	poolDictionaries:''
	category:'Languages-Java-Lookup'
!

!JavaLookup class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!JavaLookup class methodsFor:'instance creation'!

cleanup
    Static := nil.
    Instance := nil.

    "Modified: / 25-02-2011 / 14:45:03 / kursjan <kursjan@fit.cvut.cz>"
    "Created: / 29-08-2011 / 23:33:23 / Jan Kurs <kursjan@fit.cvut.cz>"
!

forInstance
    Instance ifNil: [
        Instance := self basicNew initializeInstance.
    ].
    ^ Instance.

    "Modified: / 25-02-2011 / 14:45:03 / kursjan <kursjan@fit.cvut.cz>"
    "Created: / 29-08-2011 / 21:09:41 / Jan Kurs <kursjan@fit.cvut.cz>"
!

forStatic
    Static ifNil: [
        Static := self basicNew initializeStatic.
    ].
    ^ Static.

    "Modified: / 25-02-2011 / 14:45:03 / kursjan <kursjan@fit.cvut.cz>"
    "Created: / 29-08-2011 / 21:09:35 / Jan Kurs <kursjan@fit.cvut.cz>"
!

new
    ^ self shouldNeverBeSent.

    "Created: / 25-02-2011 / 14:44:43 / kursjan <kursjan@fit.cvut.cz>"
    "Modified: / 29-08-2011 / 21:10:12 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaLookup methodsFor:'boxing-unboxing'!

boxCollection: aCollectionOrNil
    aCollectionOrNil ifNil: [ ^ nil ].
    self breakPoint: #jk.
"/    ^ aCollectionOrNil collect: [ :e | self box: e].

    "Created: / 30-08-2011 / 22:20:44 / Jan Kurs <kursjan@fit.cvut.cz>"
!

boxCollection: aCollectionOrNil toSignature: signature
    aCollectionOrNil ifNil: [ ^ nil ].
    self breakPoint: #jk.

    ^ JavaClass
        convertArgsToJava:aCollectionOrNil 
        asSpecifiedIn: signature
        numArgs:aCollectionOrNil size.
"/    ^ aCollectionOrNil collect: [ :e | self box: e].

    "Created: / 30-08-2011 / 22:24:16 / Jan Kurs <kursjan@fit.cvut.cz>"
!

unbox:jObj returnType: returnType

    "JV@2011-02-04"
    "Hack for primitive types"
    "/    JK: it is hack, but it is fast :)
    (JavaDescriptor baseTypesByTypeName keys includes: returnType) ifTrue:[^jObj].

    ^ (JavaTypeBox javaTypeAt: returnType) unbox: jObj.

"/    self breakPoint: #jk.
"/    self halt.
"/    ^ JavaClass convertToSmalltalk: value type: ((returnType copyFrom: 2 to: returnType size - 1) replaceAll: $/ by: $.).

    "Created: / 30-08-2011 / 22:13:41 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaLookup methodsFor:'initialization'!

initializeInstance
    searchStatic := false.

    "Created: / 29-08-2011 / 21:08:20 / Jan Kurs <kursjan@fit.cvut.cz>"
!

initializeStatic
    searchStatic := true.

    "Created: / 29-08-2011 / 21:08:09 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaLookup methodsFor:'lookup'!

javaSelectorsFor:class
    | selectors cls |
    cls := class.
    selectors := IdentitySet new.

    [cls = JavaObject] whileFalse: [
        cls methodDictionary keysAndValuesDo: [:k :v |
            (v isJavaMethod and: [v isStatic = searchStatic]) ifTrue: [
                selectors add: k.
            ].
        ].
        cls := cls superclass.
    ].
    ^ selectors.

    "Created: / 30-08-2011 / 20:45:57 / Jan Kurs <kursjan@fit.cvut.cz>"
!

lookupMethodForSelector:selector directedTo:initialSearchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext

    "As a courtesy to a Smalltalker, try to map smalltalk selectors to a
    java ones."
    |sm javaMethods |
    javaMethods := OrderedCollection new.

    sm := self descriptorForSmalltalkSelector: selector arguments: argArrayOrNil.
    (self javaSelectorsFor: initialSearchClass) do: [:s || jm |
        jm := self descriptorForJavaSelector: s.
        "find methods with same name and either static or non-static"
        (jm name = sm name) ifTrue: [ javaMethods add: jm ].                
    ].
    ^ self findBestMatchOf: sm in: javaMethods.

    "Created: / 21-02-2011 / 13:38:55 / kursjan <kursjan@fit.cvut.cz>"
    "Modified: / 11-04-2011 / 20:19:50 / kursjan <kursjan@fit.cvut.cz>"
    "Modified: / 16-08-2011 / 09:40:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 29-08-2011 / 20:38:21 / kursjan"
    "Modified: / 30-08-2011 / 21:54:44 / Jan Kurs <kursjan@fit.cvut.cz>"
!

perform: aMessage onReceiver: receiver from: sender
        | method  selector class args retval|
        selector := aMessage selector.
        args := aMessage arguments.
        class := receiver class.

        method := self lookupMethodForSelector: selector
                directedTo: class
                for: receiver
                withArguments: args
                from: sender.

        method ifNil: [ Error raiseErrorString: 'method not found' ].
        retval := receiver perform: method selector withArguments: args. 
        ^ self unbox: retval returnType: method returnType.

    "Modified: / 31-08-2011 / 21:35:59 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaLookup methodsFor:'matching'!

argumentMatcher
    ^ ArgumentMatcher new.

    "Created: / 29-08-2011 / 21:13:08 / Jan Kurs <kursjan@fit.cvut.cz>"
!

descriptorForJavaSelector:arg
    ^ MessageDescription new 
        parserClass: JavaSelectorParser;
        selector: arg;
        yourself.

    "Created: / 29-08-2011 / 20:41:48 / Jan Kurs <kursjan@fit.cvut.cz>"
!

descriptorForSmalltalkSelector:selector arguments: args
    ^ MessageDescription new 
        parserClass: SmalltalkSelectorParser;
        runtimeArguments: args;
        selector: selector;
        yourself.

    "Created: / 29-08-2011 / 21:44:06 / Jan Kurs <kursjan@fit.cvut.cz>"
!

findBestMatchOf: smalltalkMethod in: javaMethods
    | methods |
    javaMethods size = 1 ifTrue: [
        ^ javaMethods first.    
    ].
    javaMethods size = 0 ifTrue: [
        ^ JavaDoesNotUnderstandException raiseErrorString: 'Could not find method for selector: ', smalltalkMethod name.
    ].

    methods := javaMethods select: [:m |
        m argSize = smalltalkMethod argSize.
    ].
    methods size = 1 ifTrue: [
        ^ methods first.    
    ].

    methods := methods select: [:m |
        self argumentMatcher javaMatches: m args to: smalltalkMethod args.
    ].
    methods size = 1 ifTrue: [
        ^ methods first.
    ].

    methods size = 0 ifTrue: [
        ^ JavaDoesNotUnderstandException raiseErrorString: 'Could not find method for selector: ', smalltalkMethod name.
    ].

    ^ Error raiseErrorString: 'Ambiguous selector: ', smalltalkMethod name.

    "Created: / 29-08-2011 / 20:50:14 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaLookup class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
